<?php

namespace FiloBlu\Rma\Model\Total\Quote;

use Magento\Payment\Model\MethodList;
use Magento\Quote\Model\Quote\Address\Total;
use Magento\Quote\Model\Quote\Address\Total\AbstractTotal;
use Magento\Quote\Api\Data\ShippingAssignmentInterface;
use Magento\Quote\Model\Quote;
use Magento\Quote\Model\Quote\Address;
use Magento\Quote\Api\Data\TotalsInterface;

class CustomPrice extends AbstractTotal
{
    
    /**
     * @var \Magento\Payment\Model\MethodList
     */
    protected $methodList;
    
    /**
     * @var Magento\Quote\Api\Data\TotalsInterface
     */
    protected $totalsInterface;
    
    
    public function __construct(
        MethodList $methodList,
        TotalsInterface $totalsInterface
    ) {
        $this->methodList = $methodList;
        $this->totalsInterface = $totalsInterface;
        $this->setCode('rma_customprice');
    }

    
    public function collect(
        Quote $quote,
        ShippingAssignmentInterface $shippingAssignment,
        Total $total
    ) {
        if ($shippingAssignment->getShipping()->getAddress()->getAddressType() != Address::TYPE_SHIPPING
            || $quote->isVirtual()
        ) {
            return $this;
        }
        
        
        if($quote->getPayment()->getMethod() == 'changesizepay'):
            
            $info = $quote->getPayment()->getAdditionalInformation();
            
            $total->setDiscountPercent($info['discount_percent']);
            $total->setDiscountAmount($info['discount_amount']);
            $total->setBaseDiscountAmount($info['base_discount_amount']);
            $total->setGrandTotal($info['grand_total']);
            $total->setBaseGrandTotal($info['base_grand_total']);
            
        endif;

        return $this;
    }
    
}
